#!/bin/bash
#Script Grup Ex 2011 UPF. Coder Alvaro Jansa Mas

#NOTES SOBRE EL FUNCIONAMENT
#La idea de l script es que a partir de 2 fitxers, es pugui fer tot. El primer d'ells es troba al mateix nivell que l script i s anomena genomes_list_and_info.tab: es on es troba la infromacio de tots els genomes amb els que volem treballar. El segon fitxer es el evalue_pid.fa generat pels tblastn.
#Necesari tenir els fitxers amb les querys ben formatejats. Recomano mirar els exemples
#Necesari que el nom del fitxer.fa correspongui amb la proteina
#Recomano tenir els genomes dins la carpeta genome, al mateix lloc que el fitxer script
#Degut a un problema en l'extraccio multiFASTA,  l automatizacio nomes es  fins al fastasubseq

#Instalacio fitxers necessesaris desde intranet UPF
export PATH=/cursos/BI/bin/ncbiblast/bin:$PATH             # pel NCBI Blast
cp /cursos/BI/bin/ncbiblast/.ncbirc ~/                     # pel NCBI Blast 
export PATH=/cursos/BI/bin/exonerate/i386/bin:$PATH        # per l'exonerate
export PATH=/cursos/BI/bin:$PATH                           # pel GeneWise, el fastaseqfromGFF.pl i el t_coffee
export WISECONFIGDIR=/cursos/BI/soft/wise-2.2.0/wisecfg    # pel GeneWise
export PATH=/cursos/BI/bin/netblast/bin:$PATH              # blastcl3

#Eliminacio de fitxers temporals generats
rm *.tmp
rm prot.list
rm ids.txt
rm results.blast

#Creacio fitxer amb info basica sobre query files de la carpeta Seleno. 
for file in ./Seleno/*; do {
	protfa=`basename $file`
	pid=${protfa%.fa}
	#prot=$pid" $protfa" 
	echo $pid"	$protfa">> prot.list #OJU tabulacio 
} done
echo "Generant llista de proteines"

#Creacio de carpetes necessaries. NO TOCAR
for ruta in Tblastn Evalues Fastafetch Fastasubseq Exonerate cDNA Proteina Tcoffee Genwise ; do {
	if [ ! -d $ruta ]; then
		mkdir $ruta
	fi
} done

#tBLASTn party
for pid in Lmsel1 SelT Sel4 eEFSec PSTK SecS SEC43p SPS2; do { # indicar noms proteines, ha de ser identic al nom del fitxer fasta
	for genome in P_tricornutum H_arabidopsidis P_ultimum S_parasitica E_siliculosus C_muris C_parvum A_taiwanensis C_owczarzaki P_pallidum C_merolae T_trahens N_gruberi; do { #indiquem quins organismes volem treballar. Possible lloc de problemes per no coincidencia de noms
		
		#genomes_list_and_info.tab es el fitxer index de tots els genomes. MOLT IMPORTANT tenirlo ben formatejat
		blastdb=`grep $genome genomes_list_and_info.tab | cut -f 4`
		protf=`grep $pid prot.list | cut -f2`
		cat ./Seleno/$pid.fa | grep ^">" > query.tmp
		sed 's/#QUERY//' query.tmp > query.txt #OJU!!! el primer nom no lagafa pel >NOM

#		echo "tBLASTn per" $genome "vs" $pid # executar aquesta linia si volem obtenir tots els tBLASTn
#		blastall -p tblastn -i ./Seleno/$protf -d $blastdb -o ./Tblastn/${pid}_${genome}.tblastn 
		echo "tBLASTn per" $genome "vs" $pid "e-value 0.001"
		blastall -p tblastn -i ./Seleno/$protf -d $blastdb -o ./Tblastn/M9_${pid}_${genome}.tblastn -F F -m9 -e 0.001
	} done
	
	egrep -v "#" ./Tblastn/M9_${pid}*.tblastn | cut -f1,2,9,10,11 | sort -g -k 6,1 > evalues_${pid}.tmp #Generacio de fitxers amb els evalues i la info basica. L script treballa amb aquest fitxer
	sed 's/;/ /' evalues_${pid}.tmp | sed 's/.\/Tblastn\/M9_'${pid}_'//' | sed 's/.tblastn//' | sed 's/:/	/'> ./Evalues/evalues_${pid}.txt #Edicio del fitxer generat per a una correcta lectura
} done

#Extraccio de dades per cada fitxer evalue generat
for pid in Lmsel1 SelT Sel4 eEFSec PSTK SecS SEC43p SPS2; do { # indicar noms seleprot i maquinaria
	for genome in P_tricornutum H_arabidopsidis P_ultimum S_parasitica E_siliculosus C_muris C_parvum A_taiwanensis C_owczarzaki P_pallidum C_merolae T_trahens N_gruberi; do {

	blastdb=`grep $genome genomes_list_and_info.tab | cut -f 4`
	indexdb=${blastdb%.fa}

	x=0 
	cond=`cat ./Evalues/evalues_${pid}.txt | wc -l` # numero maxim de hits en cada fitxer evalue
	y=0

	while [ "$x" -lt "$cond" ]
		do
		let x=x+1
		gid=`head -n $x ./Evalues/evalues_${pid}.txt | tail -n 1 | cut -f1` #gid=genome id
			if [ $genome = $gid ]; then
				regio=`head -n $x ./Evalues/evalues_${pid}.txt | tail -n 1 | cut -f3` #nom de la regio en la que treballem
				let y=y+1

				echo "Iniciant FASTAfetch per "$gid "en regio " $regio
				fastafetch $blastdb $indexdb.index "$regio" > ./Fastafetch/${pid}_${genome}_${y}.txt

				st=`head -n $x ./Evalues/evalues_${pid}.txt | tail -n 1 | cut -f4` #inici de la sequencia a extreure
				start=$(( $st - 5000 ))
		#En alguns genomes sobtenen falsos positius. Cal ampliar la regio START, pero aixo pot comportar que no es trobi la regio en questio. Possible millora inclouent un if

				length="10000" #lenght es la longitud sequencia. valor arbitrari
				echo "Iniciant FASTAsubseq per "$gid "en regio" $regio
				fastasubseq ./Fastafetch/${pid}_${genome}_${y}.txt $start $length > ./Fastasubseq/${pid}_${genome}_${y}.fa

				#A partir d aquest punt l script falla degut a l extraccio multifasta automatica. De manera manual funciona, de tal manera que pot utiliztar-se la part seguent a aquest punt per a seguir amb el proces automatic
				
				
				
				
				#qid=`head -n $x ./Evalues/evalues_${pid}.txt | tail -n 1 | cut -d " " -f2 | cut -f1` #qid= qeury id, nom del query actual
				#perl extractSequence.pl ./Seleno/$pid.fa $qid > query.fa #extraccio multifasta
				#echo $qid
				#echo $regio
	
				#echo "Iniciant exonerate"
				#exonerate -E -m p2g --showtargetgff -q query.fa -t ./Fastasubseq/${pid}_${genome}_${y}.fa | egrep -w exon > ./Exonerate/EX_${pid}_${genome}_${y}.gff 
				#echo "done"
		
				#echo "Iniciant GenWise pel query" $qid "en el genoma" $genome
				#genewise -pep -pretty -cdna -both  -gff query.fa ./Fastasubseq/${pid}_${genome}_${y}.fa > ./Genwise/GW_${pid}_${genome}_${y}.fa
	
				#exon=`grep -w exon ./Exonerate/EX_${pid}_${genome}_${y}.gff`
				#echo $exon > exon.gff

				#if [ "$exon" != "" ]; then
					#echo "Executant fastaseqfromGFF.pl per EXONERATE..."${pid} ${genome} ${y}
					#perl fastaseqfromGFF.pl ./Fastasubseq/${pid}_${genome}_${y}.fa ./Exonerate/EX_${pid}_${genome}_${y}.gff > ./cDNA/cDNA_${pid}_${genome}_${y}_EX.fa

					#echo "Executant fastaseqfromGFF.pl per GeneWise"
					#perl fastaseqfromGFF.pl ./Fastasubseq/${pid}_${genome}_${y}.fa gw.gff > ./cDNA/cDNA_${pid}_${genome}_${y}_GW.fa


					#echo "Inici FASTAtranslate per EXONERATE" ${pid} ${genome} ${y}
					#fastatranslate ./cDNA/cDNA_${pid}_${genome}_${y}_EX.fa > ./Proteina/prot_${pid}_${genome}_${y}_EX.fa
					#fastatranslate ./cDNA/cDNA_${pid}_${genome}_${y}.fa > ./Proteina/prot_${pid}_${genome}_${y}.fa

					#echo "cafeconlexe...."	                
					#t_coffee ./Seleno/$pid.fa /Proteina/prot_${pid}_${genome}_${y}_EX.fa > ./Tcoffee/tcoffee_${pid}_${genome}_${y}.txt
					#echo "cafeconlexe...."	                
					#t_coffee ./Seleno/$pid.fa ./Proteina/prot_${pid}_${genome}_${y}.fa > ./Tcoffee/tcoffee_${pid}_${genome}_${y}.txt

					#echo "blastcl3" ${pid}_${genome}_${x}.fa
					#blastcl3 -p blastp -i query.fa -d nr > ./Blastp/blastp_${pid}_${genome}_${y}.txt

					#echo "blastcl3" ${pid}_${genome}_${x}.fa
					#blastcl3 -p blastp -i query.fa -d nr > ./Blastp/blastp_${pid}_${genome}_${y}.txt

		fi
	done
} done
} done
